;###############################
;##                                                                           ##
;##                      ##
;##                                                                           ##
;###############################


;-------------------------  

.include "tn2313def.inc"	;   
.list				;  

.def	temp = R16		;  
.def	temp1 = R17		;  . 
.def	count = R18		;  
.def	freq = R19		;   
.def	dfreq = R20		;    
.def	loop = R21		;  . 
.def	countp = R22            ;   

;-------------------------   

	.cseg 		;    
	.org	0	;     

start:	rjmp	init	;    
		reti	;   0
		reti	;   1
		reti	;     T1
		reti	;    T1
		reti	;    T1
		reti	;    T0
		reti	; UART -  
		reti	; UART -   
		reti	; UART -  
		reti	;   
		reti	; .   
		reti	; / 1.  B 
		reti	; / 0.  B 
		reti	; / 0.  A 
		reti	; USI -  
		reti	; USI - 
		reti	; EEPROM - 
		reti	;   
        cli     ;   

;***********************************
;*                                *
;***********************************
init:

ldi	temp, 0x7F       ;   RC-
out	OSCCAL, temp     ;    (8 )

;--------------------  
	
ldi	temp, RAMEND	;     
out	SPL, temp		;     

;--------------------   /

ldi     temp, 0x0E		; .(0,4-7) 
out   DDRB, temp                 ;,.(1-3)  
ldi     temp, 0xF1                  ;  
out   PORTB, temp               ;  .(0,4-7)

ldi 	temp, 0x7F		;   PD
out	PORTD, temp             ;    
ldi	temp, 0x00                ;   
out	DDRD, temp               ;    PD

;---------------------  (.) 

ldi 	temp, 0x80
out	ACSR, temp

;---------------------   T0
                                              
ldi  temp, 0x0B		;   CTC 
out TCCR0B, temp               ;   64
ldi  temp, 0x3D		;  0=61   
out	OCR0A, temp               ;  1 
ldi temp, 0x40		;     
out  TCCR0A, temp              ;    14  () 

;---------------------   T1
                                              
in temp, PINB                         ;   
andi temp, 0x01                    ;   
cpi temp, 0x01                       ; 1 ( S8 ) 
breq m10                                 ;  m10
ldi temp, 0x09	              ;    CTC
out TCCR1B, temp                 ;   1
rjmp	m1		              ;    m10

m10: ldi  temp, 0x0B	  ;   CTC 
          out TCCR1B, temp       ;   64

m1:  ldi temp, 0x00		 ;    
         out  TCCR1A, temp      ;   15   

;**************************************
;*                             *
;**************************************
main:

cbi PORTB, 1               ;     ( 13)
 
;---------------------    

	clr 	count		;   count 
	in	temp, PIND	;   D		
m2:	lsr 	temp		;    
	brcc 	m3		;     0
	inc	count		;   
	cpi	count, 7	;  (7 -  )
	brne	m2		;   ,  
	rjmp	m1		;      

;----------------------   
m3:
	mov	YL, count		;  , 
	ldi	ZL, low(tabp*2)	;   
	ldi	ZH, high(tabp*2)
	rcall	addw			;  / 16- 

	lpm	XL, Z+			;    
	lpm	XH, Z			;     X

;----------------------  
            
         clr       countp	            ;  c 
m4:  clr       count		;    
         inc       countp	            ;  c 
         cpi       countp, 0x1E   ;   
         breq    clark		;  ,   
        
            mov	ZH, XH	;   Z  
	mov	ZL, XL

m5:	in	temp, PIND	;    D		
	cpi	temp, 0x7F	;    7FH
	breq	m1		;   , -  
	
            lpm	temp, Z	;    
	cpi	temp, 0xFF	;     
	breq	m4		;  ,  

	andi	temp, 0x7F	;   
	mov	freq, temp	;     freq
	lpm	temp, Z+	;      
	rol	temp		;   ,  
	rol	temp		;    
	            
	andi	temp, 0x01	;    
	mov	dfreq, temp	;      dfreq

	rcall	pfreq		;  /  
	rjmp	m5		;  

clark: in temp, PINB                         ;   
           andi temp, 0x01                    ;   
           cpi temp, 0x01                       ; 1 ( S8 ) 
           breq m6                                   ;  m6
           ldi temp, 0x0B	              ;    CTC
           out TCCR1B, temp                  ;   64
           sbi PORTB,1                             ;   (.2)
           rjmp	m5		              ; . ( )

m6:    ldi temp, 0x09	;   CTC
           out TCCR1B, temp    ;   1
           sbi PORTB,1               ;   (.2)
           rjmp	m5                  ; . ( )

;***************************************
;*                      *
;***************************************

; ----------------  16-  
addw:	push	YH
		
	lsl	YL		;     2
	ldi	YH, 0		;     = 0
	add	ZL, YL		;   
	adc	ZH, YH           ;    
	                                    ;   
           pop	YH                    
	ret

;------------------   
pfreq:	push	ZH
	push	ZL
	push	YL
	push	temp
 
     cpi	freq, 0x00		;   ,  
     breq	nt1		;    

mov	YL, freq		; . ,   .
ldi	ZL, low(tabf*2)	;  ()  
ldi	ZH, high(tabf*2)
rcall	addw			;  / 16- 

lpm	temp, Z+		; . . .  
lpm	temp1, Z		; . . .  
out	OCR1AH, temp1	;   .  
out	OCR1AL, temp	;   .  
ldi	temp, 0x40		;    1 
out	TCCR1A, temp           ;   15 

nt1:	rcall	wait		;  / . 

ldi	temp, 0x00		;    1 
out	TCCR1A, temp           ;   15 

ldi	dfreq,0		;   
;rcall	wait			;   

pop	temp
pop	YL
pop	ZL
pop 	ZH
ret

;-----------------   
wait:	push	ZH
	push	ZL
	push	YH
	push	YL

mov	YL, dfreq		;  ,  
ldi	ZL, low(tabd*2)	;    
ldi	ZH, high(tabd*2)     ;  
rcall	addw			;  / 16- 

lpm	YL, Z+			;  .  
lpm	YH, Z			;  .  

clr	ZL			;    Z
clr	ZH

		;  

w1:	ldi	loop,255	;   
w2:	dec	loop                ; ( )
	brne 	w2
	adiw	R30, 1		;   Z  
	cp	YL, ZL		;  . 
	brne	w1
	cp	YH, ZH	;  . 
	brne	w1

	pop	YL		;  /
	pop	YH
	pop	ZL
	pop 	ZH
	ret

;*********************************
;*                                                  *
;*********************************

tabd:   
.dw      43636,9741

;**********************
;*                         *
;**********************
tabf:
.dw  0
.dw 124,132,142,624,627,630,634,643,660,664
.dw 701,705,726,734,739,743,720,800,861,892
.dw 905,953,968,966,976,983,1115,1135,1189,1200 
.dw 1249,1262,1275,1288,1315,1343,1358,1373,1388,1436 
.dw 1452,1523,1865,1983,2192,2357,2403,2716,3124,3204
.dw 3377,4990,5434,6249,6442,6510,6613,6648,6792,7266
.dw 7715,7812,8116,9190,11573,12754,15624,16446,17360,17856
.dw 18938,23584,24999,36764,39062,52082,62499,709,1373


;***********************************
;*                           *
;***********************************

tabp:	.dw		p1*2,p2*2,p3*2,p4*2,p5*2,p6*2,p7*2


;*********************************
;*                                    *
;*********************************

;        
p1:	
.db 73,58,54,43,38,15,14,5,5,14
.db 15,38,43,54,58,73,73,58,54,45
.db 35,31,11,10,10,11,31,35,45,54
.db 58,73,73,58,54,79,16,15,14,6
.db 6,14,15,16,79,54,58,73,73,255

;        
p2:	
.db 77,67,62,58,57,37,13,13,37,57
.db 58,62,67,77,68,65,63,58,31,28
.db 28,31,58,63,65,68,68,255 

;           
p3:	
.db 69,66,44,25,19,19,25,44,66,69
.db 69,66,50,39,12,12,39,50,69,66
.db 50,22,20,19,9,9,12,20,22,50
.db 66.69,49,19,17,9,9,17,19,49
.db 52,51,48,20,19,7,7,42,51,52
.db 52,255 

;       -  ()
p4:
.db  70,68,61,60,58,54,53,53,54,58
.db  60,61,68,70,68,67,54,26,23,23
.db  26,54,67,68,71,67,59,55,47,46
.db  30,30,46,47,55,59,67,71,71,255

;        

p5:	
.db  3,2,1,3,2,1,3,255 

;        

p6:
.db   76,68,62,57,42,41,40,8,8,40
.db   41,42,57,62,68,77,74,35,34,33
.db   32,31,29,5,5,29,31,32,33,34
.db   35,74,74,255 

;        
p7:
.db   75,59,56,27,25,24,18,78,78,18
.db   24,25,27,56,59,75,76,75,72,64
.db   59,58,56,55,55,56,58,59,64,72
.db   75,76,76,61,59,56,55,37,21,4
.db    4,21,37,55,56,59,61,76,76,255 


